import { Component, EventEmitter, Input, OnInit, Output } from "@angular/core";
import { FormBuilder, FormGroup } from "@angular/forms";
import * as _ from "lodash-es";

@Component({
  selector: "app-pd-filters",
  templateUrl: "./pd-filters.component.html",
  styleUrls:["./pd-filters.component.scss"]
})
export class PdFiltersComponent implements OnInit {
  @Input() pdFilter: any;
  @Output() filterChanged = new EventEmitter();
  pdFiltersFormGroup: FormGroup;

  constructor(public fb: FormBuilder) {}

  ngOnInit(): void {
    this.generateForm();
  }

  generateForm() {
    this.pdFiltersFormGroup = this.fb.group({});
    this.pdFiltersFormGroup.addControl(
      _.get(this.pdFilter, "reference"),
      this.fb.control("")
    );
  }

  inputChange() {
    console.log('Form value', this.pdFiltersFormGroup.value)
    const dataToBeEmitted = {
      data:this.pdFiltersFormGroup.value,
      controlType:this.pdFilter.controlType
    }
    console.log('data to emit',dataToBeEmitted)
    this.filterChanged.emit(dataToBeEmitted);
  }
}
